Go to the first, previous, next, last section, table of contents.

# 6 Settings and resources

In the VICE emulators, all the settings are stored in entities known as called resources. Each resource has a name and a value which may be either an integer or a string. Integer values are often used as boolean values with the usual convention of using zero for "false" and any other value for "true".

Resource values can be changed via the right-button menu (the settings menu), via command-line options or via the resource file.

The resource file is a human-readable file containing resource values: it is called ``vicerc'` and is stored in the directory ``.vice/'` in the user's home directory. It is possible to dump the current values of the resources into that file or load the values stored into that file as the current values, at any time. This is achieved with the "Save settings" and "Load settings" right menu items. A third menu item, "Restore Default Settings", can be used to reset all the values to the factory defaults.

A special resource, `SaveResourcesOnExit`, if set to a non zero value, causes the emulator to ask you if you want to save the current (changed) settings before exiting, and can be toggled with the "Save settings on exit" command from the right-button menu.

Notice that not all the resources can be changed from the menus; some of them can only be changed by manually modifying the resource file or by using command-line options.

## 6.1 Format of resource files

A resource file is made up of several sections; sections have the purpose of separating the resources of a certain emulator from the ones of the other emulators. A section starts with the name of an emulator in brackets (e.g., ``[C64]'`) and ends when another section starts or when the file ends.

Every line in a section has the following format:

    RESOURCE=VALUE

where `RESOURCE` is the name of a resource and `VALUE` is its assigned value. Resource names are case-sensitive and resource values are either strings or integers. Strings must start and end with a double quote character (`"`), while integers must be given in decimal notation.

Here is an example of a stripped-down ``.vice/vicerc'` file:

    [VIC20]
    HTMLBrowserCommand="netscape %s"
    SaveResourcesOnExit=0
    FileSystemDevice8=1
    FSDevice8ConvertP00=1
    FSDevice8Dir="/home/ettore/cbm/stuff/vic20p00"
    FSDevice8SaveP00=1
    FSDevice8HideCBMFiles=1
    [C64]
    HTMLBrowserCommand="netscape %s"
    SaveResourcesOnExit=1
    FileSystemDevice8=1
    FSDevice8ConvertP00=1
    FSDevice8Dir="/home/ettore/cbm/stuff/c64p00"
    FSDevice8SaveP00=1
    FSDevice8HideCBMFiles=1

Notice that, when resource values are saved with "Save settings", the emulator only modifies its own section, leaving the others unchanged.

## 6.2 Using command-line options to change resources

Resources can also be changed via command-line options.

Command-line options always override the defaults from `.vice/vicerc`, and their assignments last for the whole session. So, if you specify a certain command-line option that changes a certain resource from its default value and then use "Save Settings", the value specified with the command-line option will be saved back to the resource file.

Command-line options can begin with with a minus sign (``-'`) or with a plus sign (``+'`). Options beginning with a minus sign may require an additional parameter, while the ones beginning with the plus sign never require one.

Moreover, options beginning with a plus sign always have a counterpart with the same name, but with a minus sign; in that case, the option beginning with a minus sign is used to enable a certain feature, while the one beginning with a plus sign is used to disable the same feature (this is an X11 convention). For example, `-mitshm` enables support of MITSHM, while `+mitshm` disables it.

## 6.3 Autostart settings

### 6.3.1 Autostart resources

All these resources are available for all emulators except vsid.

`AutostartPrgDiskImage`
  String specifying the filename of the disk image used when autostarting a prg file and "copy to D64" is enabled (all emulators except vsid).
`AutostartBasicLoad`
  Boolean, if true load to basic start using ,8 when autostarting (all emulators except vsid).
`AutostartRunWithColon`
  Boolean, if true put a colon after the load command when autostarting (all emulators except vsid).
`AutostartHandleTrueDriveEmulation`
  Boolean, if true handle (enable/disable) True Drive Emulation on autostart (all emulators except vsid).
`AutostartWarp`
  Boolean, if true temporarily enable warp mode when autostarting (all emulators except vsid).
`AutostartPrgMode`
  Integer specifying the autostart mode for prg files (all emulators except vsid). (0: virtual filesystem, 1: inject to RAM, 2: copy to D64)
`AutostartDelayRandom`
  Boolean, enables a short (0-10 frames) random delay on autostart (all emulators except vsid).
`AutostartDelay`
  Integer specifying the delay in seconds required to wait for the kernal reset routine before autostart. (0: use builtin value for standard kernal) When tweaking this value start with 'large' values and then lower it, a value that is too small results in autostart not happening. (all emulators except vsid). (0..1000)

### 6.3.2 Autostart command-line options

All these command-line options are available for all emulators except vsid.

`-autostartprgdiskimage <Name>`
  Set disk image for autostart of PRG files (`AutostartPrgDiskImage`) (all emulators except vsid).
`-basicload`
  On autostart, load to BASIC start (without ',1') (`AutostartBasicLoad=1`) (all emulators except vsid).
`+basicload`
  On autostart, load with ',1' (`AutostartBasicLoad=0`) (all emulators except vsid).
`-autostartwithcolon`
  On autostart, use the 'RUN' command with a colon, i.e., 'RUN:' (`AutostartRunWithColon=1`). (all emulators except vsid)
`+autostartwithcolon`
  On autostart, do not use the 'RUN' command with a colon; i.e., 'RUN' (`AutostartRunWithColon=0`) (all emulators except vsid).
`-autostart-handle-tde`
`+autostart-handle-tde`
  Handle/Do not handle True Drive Emulation on autostart (`AutostartHandleTrueDriveEmulation=1`, `AutostartHandleTrueDriveEmulation=0`) (all emulators except vsid).
`-autostart-warp`
`+autostart-warp`
  Enable/disable warp mode during autostart (`AutostartWarp=1`, `AutostartWarp=0`) (all emulators except vsid).
`-autostartprgmode <Mode>`
  Set autostart mode for PRG files (`AutostartPrgMode`) (all emulators except vsid). (0: virtual filesystem, 1: inject to RAM, 2: copy to D64)
`-autostart-delay-random`
`+autostart-delay-random`
  Enable/disable random delay on autostart (`AutostartDelayRandom`) (all emulators except vsid).
`-autostart-delay <seconds>`
  Set initial autostart delay in seconds for the kernal reset routine before autostart. (0: use builtin value for standard kernal). When tweaking this value start with 'large' values and then lower it, a value that is too small results in autostart not happening. (`AutostartDelay`) (all emulators except vsid). (0..1000)

## 6.4 Performance settings

It is possible to control the emulation speed by using the "Maximum speed" menu item in the right-button menu. The default setting is `100`, which causes the emulation to never run faster than the real machine. A higher value allows the emulator to run faster, a lower one may force it to run slower. The setting "No limit" means to run as fast as possible, without limiting speed.

It is also possible to control the emulator's rate of frame update using the "Refresh rate" setting; the value ranges from "1/1" (update 1/1 of the frames of the real machine, that is 50 frames per second) to "1/10" (update 1 every 10 frames) and can be changed via the "Refresh Rate" submenu. The "Auto" setting means to dynamically adapt the refresh rate to the current speed of the host machine, making sure the maximum speed specified by the via "Maxium speed" is always reached if possible. In any case, the refresh rate will never be worse than 1/10 if this option is specified.

Note that you cannot simultaneously specify "Auto" as the refresh rate and "No limit" as the maximum speed..

Moreover, a special warp speed mode is provided and can be toggled with the "Enable Warp Mode" menu item. If this mode is enabled, it will cause the emulator to disable any speed limit, turn sound emulation off and use a 1/10 refresh rate, so that it will run at the maximum possible speed.

### 6.4.1 Performance resources

`Speed`
  Integer specifying the maximum relative speed, as a percentage. `0` stands for "no limit".
`RefreshRate`
  Integer specifying the refresh rate; a value of `n` specifies a refresh rate of 1/`n`. A value of `0` enables automatic frame skipping.
`WarpMode`
  Booolean specifying whether "warp mode" is turned on or not.

### 6.4.2 Performance command-line options

`-speed <percent>`
  Specifies the maximum speed as a percentage. `0` stands for "no limit" (`Speed`).
`-refresh <value>`
  Specifies refresh rate, a value of `n` specifies a refresh rate of 1/`n`. A value of `0` enables automatic frame skipping (`RefreshRate`).
`-warp`
`+warp`
  Enable/Disable warp mode (`WarpMode=1`, `WarpMode=0`).

## 6.5 Video settings

The following right-button menu items control the video output. On emulators that include two video chips (like `x128`) all options but XSync exist twice, once for each chip. XSync is shared between the video chips.

- "Video Cache" enables a video cache that can speed up the emulation when little graphics activity is going on; it is especially useful when you run the emulator on a networked X terminal as it can reduce the network bandwidth required. However, this setting can actually make the emulator slower when there is little graphics activity and the amount of work needed to maintain the cache is greater than the amount of work that would be wasted by not using it (if any).
- "Double Size" toggles double-size mode, which makes the emulation window twice as big. When emulating a 80-column PET, only the height is doubled, so that the aspect ratio is closer to that of the real thing.
- "Double Scan" toggles double-scan mode, which causes the emulator to draw only odd lines when running in double-size mode (this saves some CPU time and also makes the emulation window look more like an old monitor).
- `Use XSync()" causes the emulator to call the X11 function `XSync()` before updating the emulation window: this might be necessary on low-end systems to prevent it from consuming so many system resources that it becomes impossible for the user to interact with it.

### 6.5.1 using openGL Rastersynchronization under X11

Warning: To get full retro experience with synchronization to the vertrical raster retrace messing with X11 modelines (resolution and refresh frequencies) is necessary. This description is a suggestion - Follow this instructions at your own risk!

The following was tested under Ubuntu Linux (8.04) featuring Xorg Xserver 1:7.3+10ubuntu and mesa openGL including HW support (NVIDIA driver) supporting glx version 1.4 supplying GLX_SGI_video_sync.

It is assumed that this works also on other systems supporting the required extensions.

Preconditions:

- openGL extension GLX_SGI_video_sync in your X11 setup. The availability of the extension is checked at startup.
- XRandR extension to switch proper modes (50Hz for PAL, 60Hz for NTSC) is mandatory, proper modelines in your /etc/X11/xorg.conf must be present.

If your systems lacks 50 or 60Hz modes you might try using `gtf' (typcally shipped with Xorg, xserver) - see related man page.

You might need to add the output such as:

    # 800x600 # 50.00 Hz (GTF) hsync: 30.90 kHz; pclk: 31.15 MHz
    Modeline "800x600_50.00" 31.15 800 824 904 1008 600 601 604 618 -HSync +Vsync

to you Monitor Section of /etc/X11/xorg.conf and add the resolution to the `Screen' section.

Sometimes some consistency checks within the display driver drop this resolutions again. To drop e.g. the autodetection features in the NVIDIA driver you might add `Option "UseEDID" "FALSE"` in section `Device`.

XRandR cannot cope properly with the DynamicTwinView feature of the proprietary nvidia driver. You might need

`Option "DynamicTwinView" "False"`

to get proper results (in Screen or Device section of you xorg.conf).

ATTENTION: Disabling such features might allow X11 to access your HW in a way that it gets damaged! You are at your own risk!

Enable fullscreen (not necessary, but makes sense):

- choose your preferred resolution/refresh XRandR Resolutions and enable XRandR as fullscreen device (50Hz/PAL or 60Hz/NTSC mode).
- Activate fullscreen with `Alt-D'.
- choose `OpenGL Rastersynchronization' in the video chip menu (VIC-II Settings, VIC Setting, etc.)

Note that:

- the current implementation is dropping synchronization silently in case the display frequency isn't aligned (50Hz for PAL, 60Hz for NTSC).
- On some systems the XRandR system isn't informed about desktop display frequency changes if you switch resolutions via hotkeys like CTRL-Alt-+ (Numpad), which is possible e.g. with the X11 implementation of Xorg. In that case you can override/tell the current frequency via menu: Settings->VICII Settings->Desktop Refreshrate (e.g. in x64) (this shouldn't be necessary if you use fullscreen via XRandR.

### 6.5.2 Video resources

The following resources affect the screen emulation.

`HwScalePossible`
  Boolean that indicates whether hardware scaling is possible or not.
`openGL_sync`
  Boolean, if true enable Open-GL frame sync.
`openGL_no_sync`
  Boolean, if true Open-GL sync is not available.
`Speed`
  Integer specifying the maximum relative speed, as a percentage. `0` stands for "no limit".
`RefreshRate`
  Integer specifying the refresh rate, a value of `n` specifies a refresh rate of 1/`n`. A value of `0` enables automatic frame skipping.
`WarpMode`
  Boolean specifying whether "warp mode" is turned on or not.

## 6.6 Keyboard settings

It is possible to specify whether the "positional" or "symbolic" keyboard mapping should be used with the "Keyboard mapping type" submenu (see section 2.8 The keyboard emulation for an explanation of positional and symbolic mappings).

The keyboard settings submenu also allows you to:

- Load custom-made positional and symbolic keymap files ("Set symbolic keymap file" and "Set positional keymap file").
- Dump the current keymap to a user-defined keymap file ("Dump to keymap file").

### 6.6.1 Keyboard resources

`KeymapIndex`
  Integer identifying which keymap is being used. (0: symbolic, 1: positional, 2: symbolic (user), 3: positional (user)).
`KeymapSymFile`
  String specifying the name of the keymap file for the symbolic mapping (see section 2.8 The keyboard emulation (this will be set indirectly by changing `KeymapIndex`, `KeyboardMapping` or `KeyboardType`).
`KeymapPosFile`
  String specifying the name of the keymap file for the positional mapping (see section 2.8 The keyboard emulation (this will be set indirectly by changing `KeymapIndex`, `KeyboardMapping` or `KeyboardType`).
`KeymapUserSymFile`
  String specifying the name of the user keymap file for symbolic mapping (see section 2.8 The keyboard emulation
`KeymapUserPosFile`
  String specifying the name of the user keymap file for positional mapping (see section 2.8 The keyboard emulation
`KeyboardMapping`
  Integer specifying the keyboard layout of the host. (0: American 1: British 2: German 3: Danish 4: Norwegian 5: Finnish 6: Italian).
`KeyboardType`
  Integer specifying the emulated type of keyboard. (machine specific, currently always 0 except for xpet: 0: Business (us) 1: Business (uk) 2: Business (de) 3: Business (jp) 4: Graphics (us)).

### 6.6.2 Keyboard command-line options

`-keymap <number>`
  Specifies which keymap is being used (`KeymapIndex` 0: symbolic, 1: positional, 2: symbolic (user), 3: positional (user)).
`-symkeymap <Name>`
  Specify filename of the symbolic user keymap file (`KeymapUserSymFile`).
`-poskeymap <Name>`
  Specify filename of the positional user keymap file (`KeymapUserPosFile`).
`-keyboardmapping <number>`
  Specifies the keyboard layout of the host (`KeyboardMapping` 0: American 1: British 2: German 3: Danish 4: Norwegian 5: Finnish 6: Italian).
`-keyboardtype <number>`
  Specifies the emulated type of keyboard (`KeyboardType` machine specific, currently always 0 except for xpet: 0: Business (us) 1: Business (uk) 2: Business (de) 3: Business (jp) 4: Graphics (us)).

The control port settings submenu allows you to select which control port device is connected to a control port.

### 6.6.3 Control port resources

`JoyPort1Device`
  Set the device attached to: control port 1 (x64/x64sc/x64dtv/xscpu/x128/xcbm5x0/xplus4) control port (xvic). (x64/x64sc/xscpu/x128/xcbm5x0/xvic: 0: None, 1: Joystick, 2: Paddles, 3: Mouse (1351), 4: Mouse (NEOS), 5: Mouse (Amiga), 6: Mouse (CX-22), 7: Mouse (Atari ST), 8: Mouse (SmartMouse), 9: Mouse (Micromys), 10: KoalaPad, 11: Light Pen (up trigger), 12: Light Pen (left trigger), 13: Datel Light Pen, 14: Magnum Light Phaser, 15: Stack Light Rifle, 16: Inkwell Light Pen, 17: Sampler (2bit)) (x64dtv/xplus4: 0: None, 1: Joystick, 6: Mouse (CX-22), 17: Sampler (2bit))
`JoyPort2Device`
  Set the device attached to: control port 2 (x64/x64sc/x64dtv/xscpu/x128/xcbm5x0/xplus4) (x64/x64sc/xscpu/x128/xcbm5x0: 0: None, 1: Joystick, 2: Paddles, 3: Mouse (1351), 4: Mouse (NEOS), 5: Mouse (Amiga), 6: Mouse (CX-22), 7: Mouse (Atari ST), 8: Mouse (SmartMouse), 9: Mouse (Micromys), 10: KoalaPad, 17: Sampler (2bit)) (x64dtv/xplus4: 0: None, 1: Joystick, 6: Mouse (CX-22), 17: Sampler (2bit))
`JoyPort3Device`
  Set the device attached to: userport joystick adapter port 1 (x64/x64sc/xscpu/x128/xcbm2/xpet/xvic) userport joystick adapter port (x64dtv) sidcart control port (xplus4). (x64/x64sc/x64dtv/xscpu/x128/xcbm2/xpet/xvic: 0: None, 1: Joystick, 6: Mouse (CX-22), 17: Sampler (2bit)) (xplus4: 0: None, 1: Joystick, 2: Paddles, 3: Mouse (1351), 4: Mouse (NEOS), 5: Mouse (Amiga), 6: Mouse (CX-22), 7: Mouse (Atari ST), 8: Mouse (SmartMouse), 9: Mouse (Micromys), 10: KoalaPad, 17: Sampler (2bit))
`JoyPort4Device`
  Set the device attached to: userport joystick adapter port 2 (x64/x64sc/xscpu/x128/xcbm2/xpet/xvic) (x64/x64sc/xscpu/x128/xcbm2/xpet/xvic: 0: None, 1: Joystick, 6: Mouse (CX-22), 17: Sampler (2bit))

### 6.6.4 Control port command-line options

`-controlport1device <device>`
  Set the device attached to: control port 1 (x64/x64sc/x64dtv/xscpu/x128/xcbm5x0/xplus4) control port (xvic) (`JoyPort1Device`). (x64/x64sc/xscpu/x128/xcbm5x0/xvic: 0: None, 1: Joystick, 2: Paddles, 3: Mouse (1351), 4: Mouse (NEOS), 5: Mouse (Amiga), 6: Mouse (CX-22), 7: Mouse (Atari ST), 8: Mouse (SmartMouse), 9: Mouse (Micromys), 10: KoalaPad, 11: Light Pen (up trigger), 12: Light Pen (left trigger), 13: Datel Light Pen, 14: Magnum Light Phaser, 15: Stack Light Rifle, 16: Inkwell Light Pen, 17: Sampler (2bit)) (x64dtv/xplus4: 0: None, 1: Joystick, 6: Mouse (CX-22), 17: Sampler (2bit))
`-controlport2device <device>`
  Set the device attached to: control port 2 (x64/x64sc/x64dtv/xscpu/x128/xcbm5x0/xplus4) (`JoyPort2Device`). (x64/x64sc/xscpu/x128/xcbm5x0: 0: None, 1: Joystick, 2: Paddles, 3: Mouse (1351), 4: Mouse (NEOS), 5: Mouse (Amiga), 6: Mouse (CX-22), 7: Mouse (Atari ST), 8: Mouse (SmartMouse), 9: Mouse (Micromys), 10: KoalaPad, 17: Sampler (2bit)) (x64dtv/xplus4: 0: None, 1: Joystick, 6: Mouse (CX-22), 17: Sampler (2bit))
`-controlport3device <device>`
  Set the device attached to: userport joystick adapter port 1 (x64/x64sc/xscpu/x128/xcbm2/xpet/xvic) userport joystick adapter port (x64dtv) sidcart control port (xplus4) (`JoyPort3Device`). (x64/x64sc/x64dtv/xscpu/x128/xcbm2/xpet/xvic: 0: None, 1: Joystick, 6: Mouse (CX-22), 17: Sampler (2bit)) (xplus4: 0: None, 1: Joystick, 2: Paddles, 3: Mouse (1351), 4: Mouse (NEOS), 5: Mouse (Amiga), 6: Mouse (CX-22), 7: Mouse (Atari ST), 8: Mouse (SmartMouse), 9: Mouse (Micromys), 10: KoalaPad, 17: Sampler (2bit))
`-controlport4device <device>`
  Set the device attached to: userport joystick adapter port 2 (x64/x64sc/xscpu/x128/xcbm2/xpet/xvic) (`JoyPort4Device`). (x64/x64sc/xscpu/x128/xcbm2/xpet/xvic: 0: None, 1: Joystick, 6: Mouse (CX-22), 17: Sampler (2bit))

## 6.7 Joystick settings

### 6.7.1 Joystick resources

`JoyDevice1`
`JoyDevice2`
`JoyDevice3`
`JoyDevice4`
  Integer specifying which joystick device the emulator should use for joystick emulation for ports 1 - 4, respectively. (0=None, 1=Joystick 1, 2=Joystick 2, 4=Numpad, 8=Keyset 1, 16=Keyset 2 on OS/2) (0=None, 1=Numpad, 2=Keyset 1, 3=Keyset 2, 4=HID joystick 0, 5=HID joystick 1 on Mac OS X) The available joysticks might differ depending on operating system and joystick support in the OS (Linux joystick module must be available for example).
`JoyOpposite`
  Boolean, if true allow (usually impossible) bitcombinations for opposite directions. (all emulators except vsid)
`UserportJoy`
  Boolean to enable/disable extra joysticks (all emulators except xcbm5x0 and vsid).
`UserportJoyType`
  Integer specifying the type of adapter used for the extra joysticks (all emulators except xcbm5x0 and vsid). (0: Classical Games/Protovision, 1: PET, 2: Hummer, 3: OEM, 4: Digital Excess/Hitmen, 5: Kingsoft, 6: Starbyte) 4, 5 and 6 are x64, x64sc, xscpu64 and x128 only.
`Mouse`
  Boolean, enables mouse emulation
`KeySet1NorthWest`
`KeySet1North`
`KeySet1NorthEast`
`KeySet1East`
`KeySet1SouthEast`
`KeySet1South`
`KeySet1SouthWest`
`KeySet1West`
`KeySet1Fire`
  Integers specifying the keycodes for keyset 1 (all emulators except vsid).
`KeySet2NorthWest`
`KeySet2North`
`KeySet2NorthEast`
`KeySet2East`
`KeySet2SouthEast`
`KeySet2South`
`KeySet2SouthWest`
`KeySet2West`
`KeySet2Fire`
  Integers specifying the keycodes for keyset 2 (all emulators except vsid).
`KeySetEnable`
  Boolean that specifies whether user defined keysets are enabled (all emulators except vsid).
`KbdbufDelay`
  Integer specifying the additional keyboard delay. (0: use default)

### 6.7.2 Joystick command-line options

`-joydev1 <range>`
`-joydev2 <range>`
  Set the device for joystick emulation of port 1 and 2, respectively. (`JoyDevice1`, `JoyDevice2`). The range for OS/2 is, valid numbers in the range are 0, 1, 2, 4, 8 and 16.
`-extrajoydev1 <0-8>`
`-extrajoydev2 <0-8>`
  Set device for extra joystick port 1 and 2.
`-joyopposite`
`+joyopposite`
  Enable/disable opposite joystick directions (`JoyOpposite=1`, `JoyOpposite=0`). (all emulators except vsid)
`-userportjoy`
`+userportjoy`
  Enable/disable extra joystick(s) (`UserportJoy=1`, `UserportJoy=0`). (all emulators except xcbm5x0 and vsid).
`-userportjoytype <Type>`
  Set extra joystick type (`UserportJoyType`) (all emulators except xcbm5x0 and vsid). (0: Classical Games/Protovision, 1: PET, 2: Hummer, 3: OEM, 4: Digital Excess/Hitmen, 5: Kingsoft, 6: Starbyte) 4, 5 and 6 are x64, x64sc, xscpu64 and x128 only.
`-mouse`
`+mouse`
  Enable/Disable mouse grab
`-keyset`
`+keyset`
  Enable/disable user defined keyset (`KeySetEnable=1`, `KeySetEnable=0`) (all emulators except vsid).
`-keybuf-delay <value>`
  Set additional keyboard buffer delay (`KbdbufDelay`). (0: use default)

## 6.8 Sound settings

The following menu items control sound output:

- "Enable sound playback" turns sound emulation on and off.
- "Sound synchronization" specifies the method for syncronizing the sound playback. Possible settings are:
  - "Flexible", i.e., the audio renderer flexibly adds/removes samples to the output to smoothly adapt the playback to slight changes in the speed of the emulator.
  - "Adjusting" works like "flexible", but supports bigger differences in speed. For example, if the emulation speed drops down from from 100% to 50%, audio slows down by the same amount too.
  - "Exact", instead, makes the audio renderer output always the same sounds you would hear from the real thing, without trying to adapt the ratio; to compensate the tolerances in speed, some extra frames will be skipped or added.
- "Sample rate" specifies the sampling frequency, ranging from 8000 to 48000 Hz (not all the sound cards and/or sound drivers can support all the frequencies, so actually the nearest candidate will be chosen).
- "Buffer size" specifies the size of the audio buffer; the bigger the buffer, the longer the delay with which sounds are played. You should pick the smallest value your machine can handle without problems.
- "Sound suspend time", will cause the audio playback to pause for the specified number of seconds whenever some clicking happens. If "Keep going" is selected, no pausing is done.

### 6.8.1 Sound resources

`Sound`
  Boolean specifying whether audio emulation is turned on.
`SoundSpeedAdjustment`
  Integer specifying what speed adjustment method the audio renderer should use. (0: flexible, 1: adjusting, 2: exact)
`SoundSampleRate`
  Integer specifying the sampling frequency in Hz (not all the sound cards and/or sound drivers can support all the frequencies, so actually the nearest candidate will be chosen). (8000..48000)
`SoundBufferSize`
  Integer specifying the size of the audio buffer, in milliseconds.
`SoundSuspendTime`
  Integer specifying the pause interval when audio underflows ("clicks") happen. `0` means no pause is done.
`SoundDeviceName`
  String specifying the audio driver. Implemented drivers are:
  - `ahi`, for the Amiga/Morphos/Aros sound driver.
  - `aix`, for the IBM AIX sound driver.
  - `allegro`, for the DOS Allegro sound driver.
  - `alsa`, for the linux ALSA sound driver.
  - `arts`, for the *nix ARTS sound driver.
  - `beos`, for the BeOS/Zeta/Haiku sound driver.
  - `bsp`, for the BeOS/Zeta/Haiku BeOS Media Kit sound driver.
  - `coreaudio`, for the Mac OS X sound driver (`SoundDeviceArg` specifies the audio device, default system output by default).
  - `dart`, for the OS/2 sound driver.
  - `dummy`, fully emulating the sound output chip(s), but not actually playing samples.
  - `dx`, for the Windows Direct-X sound driver.
  - `hpux`, for the HP-UX audio device (unfinished; `SoundDeviceArg` specifies the audio device, ``/dev/audio'` by default).
  - `midas`, for the DOS Midas sound driver.
  - `pulse`, for the Pulseaudio sound driver.
  - `sdl`, for the Simple DirectMedia Layer audio driver.
  - `sgi`, for the Silicon Graphics audio device (`SoundDeviceArg` specifies the audio device, ``/dev/audio'` by default);
  - `speed`, like `dummy` but also calculating samples (mainly used to evaluate the speed of the sample generator);
  - `sun`, for the Solaris and NetBDS audio device (unfinished; `SoundDeviceArg` specifies the audio device, ``/dev/audio'` by default).
  - `uss`, for the Linux/FreeBSD Universal Sound System driver (`SoundDeviceArg` specifies the audio device, ``/dev/dsp'` by default);
  - `wmm`, for the Windows Multimedia Waveout sound device.
  These drivers will actually be present only if the VICE configuration script detected the corresponding development support at the time of compilation.
`SoundDeviceArg`
  String specifying an additional parameter for the audio driver (see `SoundDeviceName`).
`SoundRecordDeviceName`
  String specifying the driver used for sound recording. Implemented drivers are:
  - `aiff`, for the Apple Interchange File Format 16bit sound recorder driver.
  - `dump`, writing all the write accesses to the registers to a file (specified by `SoundDeviceArg`, default value is `vicesnd.sid`);
  - `fs`, writing samples to a file (specified by `SoundDeviceArg`; default is ``vicesnd.raw'`); `iff`, for the Amiga Interchange File Format (8SVX) 8bit sound recorder driver.
  - `mp3`, for the MP3 sound recorder driver.
  - `flac`, for the FLAC sound recorder driver.
  - `ogg`, for the ogg/vorbis sound recorder driver.
  - `voc`, for the Creative Voice (VOC) sound recorder driver.
  - `wav`, for the RIFF/WAV sound recorder driver.
  These drivers will actually be present only if the VICE configuration script detected the corresponding development support at the time of compilation.
`SoundRecordDeviceArg`
  String specifying additional arguments for sound recording.
`SoundFragmentSize`
  Integer specifying the fragment size. (0: very small, 1: small, 2: medium, 3: large, 4: very large)
`SoundVolume`
  Integer specifying the master volume in percent. (0..100)
`SoundOutput`
  Integer specifying the type of sound output. Output is selectable between 'system' (system decides to use mono or stereo output based on the presence of a stereo sid), 'always mono' (output is always mono, stereo streams are mixed into a mono stream) or 'always stereo' (output is always stereo, mono streams are multiplexed to a stereo stream). (0: system, 1: mono, 2: stereo)

### 6.8.2 Sound command-line options

`-sound`
`+sound`
  Enable/disable sound emulation (`Sound=1`, `Sound=0`).
`-soundsync <sync>`
  Specify the sound speed adjustment method (`SoundSpeedAdjustment`). (0: flexible, 1: adjusting, 2: exact)
`-soundrate <value>`
  Specify the sound playback sample rate (`SoundSampleRate`). (8000..48000)
`-soundoutput <output mode>`
  Sound output mode (`SoundOutput`). (0: system decides mono/stereo, 1: always mono, 2: always stereo)
`-soundbufsize <value>`
  Specify the size of the audio buffer in milliseconds (`SoundBufferSize`).
`-soundfragsize <value>`
  Set sound fragment size (`SoundFragmentSize`). (0: very small, 1: small, 2: medium, 3: large, 4: very large)
`-sounddev <Name>`
  Specifies the name of the audio device (`SoundDeviceName`). (ahi/aix/allegro/alsa/arts/beos/bsp/coreaudio/dart/dummy/dx/hpux/midas/pulse/sdl/sgi/sun/uss/wmm)
`-soundarg <args>`
  Specifies an additional parameter for the audio device (`SoundDeviceArg`).
`-soundrecdev <name>`
  Specify recording sound driver (`SoundRecordDeviceName`). (aiff/dump/fs/iff/mp3/flac/ogg/speed/voc/wav)
`-soundrecarg <args>`
  Specify initialization parameters for recording sound driver (`SoundRecordDeviceArg`).
`-soundsuspend <seconds>`
  Specify the pause interval when audio underflows (clicks) happen. 0 means no pause is done (`SoundSuspendTime`).
`-soundvolume <volume>`
  Specify the sound volume (`SoundVolume`). (0..100)

## 6.9 Tape settings

These settings are used to control the hardware-level emulation of the Tape drive.

### 6.9.1 Tape resources

`DatasetteResetWithCPU`
  Boolean specifying whether to reset (rewind) the tape when resetting the CPU.
`DatasetteZeroGapDelay`
  Integer specifying the delay in cycles for a zero in the tap.
`DatasetteSpeedTuning`
  Integer specifying the number of cycles added to each gap in the tap.
`DatasetteTapeWobble`
  Integer specifying the maximum random number of cycles added to each gap in the tap.

### 6.9.2 Tape command-line options

`-dsresetwithcpu`
`+dsresetwithcpu`
  Enable/disable automatic Datasette-Reset (`DatasetteResetWithCPU=1`, `DatasetteResetWithCPU=0`).
`-dszerogapdelay <value>`
  Set delay in cycles for a zero in the tap (`DatasetteZeroGapDelay`).
`-dsspeedtuning <value>`
  Set number of cycles added to each gap in the tap (`DatasetteSpeedTuning`).
`-dstapewobble <value>`
  Set maximum random number of cycles added to each gap in the tap (`DatasetteTapeWobble`).

## 6.10 Drive settings

These settings are used to control the hardware-level emulation of the Disk drives. When hardware-level emulation is turned on, only drives 8 and 9 are being emulated.

The following settings affect both drives:

- "Enable true drive emulation" enables the (slow) hardware-level emulation of the drives for maximum compatibility. This must be turned on for any of the following settings to have effect.
- "Drive sync factor" specifies the speed of the drive's CPU. This can be used to help loading certain programs that have trouble with the default PAL setting (for example, programs designed for NTSC machines). The ratio is calculated as follows:

      sync_factor = 65536 * clk_drive / clk_machine

  where `clk_drive` and `clk_machine` are clock speeds in MHz. The menu lets you choose between the PAL and NTSC values, and also lets you specify whatever value you want. Be careful when changing it, though, because a wrong value can break things and even corrupt disk images.

The following settings, instead, are specific of each drive:

- "Drive model" specifies the model of the drive being emulated. Warning: This will reset the drive.
- "Enable parallel cable" enables emulation of a SpeedDOS parallel cable; if you switch this option on and replace the original Commodore ROMs with SpeedDOS-compatible ones, you can speed up loading/saving times.
- "Idle method" specifies which method the drive emulation should use to save CPU cycles in the host CPU. There are three methods:
  - Skip cycles: Each time the serial line is accessed by the C64, the drive executes all the cycles since the last time it ran. If the number of elapsed cycles is larger than a certain value, the drive discards part of them.
  - Trap idle: The disk drive is still emulated upon serial line accesses as with the previous option, but it is also always emulated at the end of each screen frame. If the drive gets into the DOS idle loop, only pending interrupts are emulated to save time.
  - No traps: Like "Trap idle", but without any traps at all. So basically the drive works exactly as with the real thing, and nothing is done to reduce the power needs of the drive emulation.
  The first option ("Skip cycles") is usually best for performance, as the drive is emulated as little as possible; on the other hand, you may notice sudden slowdowns (when the drive executes several cycles at once) and the LED status is never updated (because it would not be possible to do correctly so). Moreover, if the drive tries to get in sync with the computer in some weird way and the computer does not access the serial line for a long time, it is possible that some cycles are discarded and the sync is lost. Notice that this hack will have no effect on performance if a program continuously reads from the IEC port, as the drive will have to be fully emulated in any case (some stupid programs do this, even when they don't actually need to use the drive).

  The second option ("Trap idle") is usually a bit slower, as at least interrupts are always emulated, but ensures the LED state is always updated correctly and always keeps the drive and the computer in sync. On the other hand, if a program installs a non-standard idle loop in the drive, the drive CPU has to be emulated even when not necessary and the global emulation speed is then much slower.

- "40-track image support" specifies how 40-track ("extended") disk images should be supported. There are three possible ways:
  - "Never extend" never extends disk images at all (so if a program tries to write tracks beyond the 35th, it is not allowed to do so);
  - "Ask on extend" prompts the user as soon as a program tries to write tracks beyond the 35th, and the user can then choose whether he wants the disk image to be extended or not;
  - "Extend on access" simply extends the disk image as soon the program needs it, without prompting the user.

### 6.10.1 Drive resources

`RawDriveDriver`
  String specifying the name of the device to be used for raw block access.
`DriveTrueEmulation`
  Boolean controlling whether the "true" drive emulation is turned on.
`DriveSoundEmulation`
  Boolean controlling whether the drive noise emulation is turned on (all emulators except vsid).
`DriveSoundEmulationVolume`
  Integer specifying the volume of the drive noise emulation (all emulators except vsid). (0..4000)
`Drive8Type`
`Drive9Type`
`Drive10Type`
`Drive11Type`
  Integers specifying the model number for drives 8 to 11. Possible values are `1541` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1542` (1541-II) [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1570` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1571` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1573` (1571CR) [x128 only], `1551` [xplus4 only], `1581` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1001` [all emulators except x64dtv, xplus4 and vsid], `2000` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `2031` [all emulators except x64dtv, xplus4 and vsid], `2040` [all emulators except x64dtv, xplus4 and vsid], `3040` [all emulators except x64dtv, xplus4 and vsid], `4000` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `4040` [all emulators except x64dtv, xplus4 and vsid], `8050` [all emulators except x64dtv, xplus4 and vsid], `8250` [all emulators except x64dtv, xplus4 and vsid].
`Drive8RTCSave`
  Integer specifying whether the RTC data of drive 8 should be saved when changed or not (drive type 2000/4000 only).
`Drive9RTCSave`
  Integer specifying whether the RTC data of drive 9 should be saved when changed or not (drive type 2000/4000 only).
`Drive10RTCSave`
  Integer specifying whether the RTC data of drive 10 should be saved when changed or not (drive type 2000/4000 only).
`Drive11RTCSave`
  Integer specifying whether the RTC data of drive 11 should be saved when changed or not (drive type 2000/4000 only).
`Drive8ParallelCable`
`Drive9ParallelCable`
`Drive10ParallelCable`
`Drive11ParallelCable`
  integers controlling what type of parallel cable is emulated for drives 8 to 11 (x64, x64sc, xscpu64, x128 and xplus4 only). x64/x64sc/xscpu64/x128: (0: None, 1: Standard, 2: Professional DOS, 3: Formel64) xplus4: (0: None, 1: Standard)
`Drive8ProfDOS`
`Drive9ProfDOS`
`Drive10ProfDOS`
`Drive11ProfDOS`
  Booleans controlling whether Professional DOS is emulated or not for drives 8 to 11 (x64, x64sc, xscpu64 and x128 only).
`Drive8SuperCard`
`Drive9SuperCard`
`Drive10SuperCard`
`Drive11SuperCard`
  Booleans controlling whether Super Card is emulated or not for drives 8 to 11 (x64, x64sc, xscpu64 and x128 only).
`Drive8RAM2000`
`Drive8RAM4000`
`Drive8RAM6000`
`Drive8RAM8000`
`Drive8RAMA000`
`Drive9RAM2000`
`Drive9RAM4000`
`Drive9RAM6000`
`Drive9RAM8000`
`Drive9RAMA000`
`Drive10RAM2000`
`Drive10RAM4000`
`Drive10RAM6000`
`Drive10RAM8000`
`Drive10RAMA000`
`Drive11RAM2000`
`Drive11RAM4000`
`Drive11RAM6000`
`Drive11RAM8000`
`Drive11RAMA000`
  Booleans controlling whether a RAM block is emulated at the respective block or not for drives 8 to 11 respectively.
`Drive8ExtendImagePolicy`
`Drive9ExtendImagePolicy`
`Drive10ExtendImagePolicy`
`Drive11ExtendImagePolicy`
  Integer specifying the policy for 40-track support for drives 8 to 11. (0: never extend, 1: ask on extend, 2: extend on access)
`Drive8IdleMethod`
`Drive9IdleMethod`
`Drive10IdleMethod`
`Drive11IdleMethod`
  Integers specifying the idling method for the drive CPU. See section 6.10 Drive settings. (0: none, 1: skip cycles, 2: trap idle)
`Drive8RPM`
`Drive9RPM`
`Drive10RPM`
`Drive11RPM`
  Integers specifying the rotation speed of the drive, multiplied by 100 so 300rpm equal 30000.
`Drive8Wobble`
`Drive9Wobble`
`Drive10Wobble`
`Drive11Wobble`
  Integers specifying the random wobble that will be added the rotation speed.
`DosName1540`
`DosName1541`
`DosName1541ii`
`DosName1570`
`DosName1571`
`DosName1581`
`DosName2000`
`DosName4000`
  Strings specifying the names of the ROM images for the drive emulation. (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`DosName1551`
  String specifying the name of the ROM image for the drive emulation. (xplus4 only)
`DosName1571cr`
  String specifying the name of the ROM image for the drive emulation. (x128 only)
`DosName2031`
`DosName2040`
`DosName3040`
`DosName4040`
`DosName1001`
  Strings specifying the names of the ROM images for the drive emulation. (all emulators except x64dtv, xplus4 and vsid)
`DriveProfDOS1571Name`
  String specifying the filename of the 1571 professional DOS ROM image (x64, x64sc, xscpu64 and x128 only).
`DriveSuperCardName`
  String specifying the filename of the Super Card ROM image (x64, x64sc, xscpu64 and x128 only).

### 6.10.2 Drive command-line options

`-truedrive`
`+truedrive`
  Enable/disable true drive emulation (`DriveTrueEmulation=1`, `DriveTrueEmulation=0`).
`-drivesound`
`+drivesound`
  Enable/disable drive sound emulation (`DriveSoundEmulation=1`, `DriveSoundEmulation=0`) (all emulators except vsid).
`-drivesoundvolume <Volume>`
  Set the volume of the drive sound emulation (`DriveSoundEmulationVolume=1`, `DriveSoundEmulationVolume=0`) (all emulators except vsid).
`-drive8type <Type>`
`-drive9type <Type>`
`-drive10type <Type>`
`-drive11type <Type>`
  Specifies the drive types for drives 8-11, respectively. Possible values for `TYPE` are `1541` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1542` (meaning 1541-II) [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1551` [xplus4 only], `1570` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1571` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `1573` (meaning 1571cr) [x128 only], `1581` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `2000` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `4000` [all emulators except xcbm2, xcbm5x0, xpet and vsid], `2031` [all emulators except x64dtv, xplus4 and vsid], `2040` [all emulators except x64dtv, xplus4 and vsid], `3040` [all emulators except x64dtv, xplus4 and vsid], `4040` [all emulators except x64dtv, xplus4 and vsid], `1001` [all emulators except x64dtv, xplus4 and vsid], `8050` [all emulators except x64dtv, xplus4 and vsid] and `8250` [all emulators except x64dtv, xplus4 and vsid].
`-drive8rtcsave`
`-drive8rtcsave`
  Enable/disable the saving of the RTC data for drive 8 when changed (drive type 2000/4000 only) (`Drive8RTCSave=1`, `Drive8RTCSave=0`).
`-drive9rtcsave`
`-drive9rtcsave`
  Enable/disable the saving of the RTC data for drive 9 when changed (drive type 2000/4000 only) (`Drive9RTCSave=1`, `Drive9RTCSave=0`).
`-drive10rtcsave`
`-drive10rtcsave`
  Enable/disable the saving of the RTC data for drive 10 when changed (drive type 2000/4000 only) (`Drive10RTCSave=1`, `Drive10RTCSave=0`).
`-drive11rtcsave`
`-drive11rtcsave`
  Enable/disable the saving of the RTC data for drive 11 when changed (drive type 2000/4000 only) (`Drive11RTCSave=1`, `Drive11RTCSave=0`).
`-parallel8 <type>`
`-parallel9 <type>`
`-parallel10 <type>`
`-parallel11 <type>`
  Set parallel cable type for drives 8-11 respectively (`Drive8ParallelCable`, `Drive9ParallelCable`, `Drive10ParallelCable`, `Drive11ParallelCable`) (x64, x64sc, xscpu64, x128 and xplus4 only). x64/x64sc/xscpu64/x128: (0: None, 1: Standard, 2: Professional DOS, 3: Formel64) xplus4: (0: None, 1: Standard)
`-drive8idle <method>`
`-drive9idle <method>`
`-drive10idle <method>`
`-drive11idle <method>`
  Specifies <method> as the idling method for drives 8-11 respectively (`Drive8IdleMethod`, `Drive9IdleMethod`, `Drive10IdleMethod`), `Drive11IdleMethod`). (0: none, 1: skip cycles, 2: trap idle)
`-drive8extend <method>`
`-drive9extend <method>`
`-drive10extend <method>`
`-drive11extend <method>`
  Specifies <method> as the track 40 extend policy in drives 8-11 respectively (`Drive8ExtendImagePolicy`, `Drive9ExtendImagePolicy`, `Drive10ExtendImagePolicy`, `Drive11ExtendImagePolicy`). (0: never extend, 1: ask on extend, 2: extend on access)
`-drive8rpm <rpm>`
`-drive9rpm <rpm>`
`-drive10rpm <rpm>`
`-drive11rpm <rpm>`
  Specifies the rotation speed of the drive, multiplied by 100 so 300rpm equal 30000.
`-drive8wobble <wobble>`
`-drive9wobble <wobble>`
`-drive10wobble <wobble>`
`-drive11wobble <wobble>`
  Specifies random amount of wobble added to the rotation speed.
`-dos1540 <name>`
  Specify the ROM name for the 1540 emulation (`DosName1540`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos1541 <name>`
  Specify the ROM name for the 1541 emulation (`DosName1541`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos1541II <name>`
  Specify the ROM name for the 1541-II emulation (`DosName1541ii`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos1551 <name>`
  Specify the ROM name for the 1551 emulation (`DosName1551`). (xplus4 only)
`-dos1570 <name>`
  Specify the ROM name for the 1570 emulation (`DosName1570`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos1571 <name>`
  Specify the ROM name for the 1571 emulation (`DosName1571`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos1571cr <name>`
  Specify the ROM name for the 1571 emulation (`DosName1571CR`). (x128 only)
`-dos1581 <name>`
  Specify the ROM name for the 1581 emulation (`DosName1581`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos2000 <name>`
  Specify the ROM name for the FD2000 emulation (`DosName2000`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos4000 <name>`
  Specify the ROM name for the FD4000 emulation (`DosName4000`). (all emulators except xcbm2, xcbm5x0, xpet and vsid)
`-dos2031 <name>`
  Specify the ROM name for the 2031 emulation (`DosName2031`). (all emulators except x64dtv, xplus4 and vsid)
`-dos2040 <name>`
  Specify the ROM name for the 2040 emulation (`DosName2040`). (all emulators except x64dtv, xplus4 and vsid)
`-dos3040 <name>`
  Specify the ROM name for the 3040 emulation (`DosName3040`). (all emulators except x64dtv, xplus4 and vsid)
`-dos4040 <name>`
  Specify the ROM name for the 4040 emulation (`DosName4040`). (all emulators except x64dtv, xplus4 and vsid)
`-dos1001 <name>`
  Specify the ROM name for the 1001, 8050 and 8250 emulations (`DosName1001`). (all emulators except x64dtv, xplus4 and vsid)
`-drive8ram2000, +drive8ram2000`
  Enable/disable 8KB RAM expansion at $2000-$3FFF for drive 8 (`Drive8RAM2000=1`, `Drive8RAM2000=0`).
`-drive9ram2000, +drive9ram2000`
  Enable/disable 8KB RAM expansion at $2000-$3FFF for drive 9 (`Drive9RAM2000=1`, `Drive9RAM2000=0`).
`-drive10ram2000, +drive10ram2000`
  Enable/disable 8KB RAM expansion at $2000-$3FFF for drive 10 (`Drive10RAM2000=1`, `Drive10RAM2000=0`).
`-drive11ram2000, +drive11ram2000`
  Enable/disable 8KB RAM expansion at $2000-$3FFF for drive 11 (`Drive11RAM2000=1`, `Drive11RAM2000=0`).
`-drive8ram4000, +drive8ram4000`
  Enable/disable 8KB RAM expansion at $4000-$5FFF for drive 8 (`Drive8RAM4000=1`, `Drive8RAM4000=0`).
`-drive9ram4000, +drive9ram4000`
  Enable/disable 8KB RAM expansion at $4000-$5FFF for drive 9 (`Drive9RAM4000=1`, `Drive9RAM4000=0`).
`-drive10ram4000, +drive10ram4000`
  Enable/disable 8KB RAM expansion at $4000-$5FFF for drive 10 (`Drive10RAM4000=1`, `Drive10RAM4000=0`).
`-drive11ram4000, +drive11ram4000`
  Enable/disable 8KB RAM expansion at $4000-$5FFF for drive 11 (`Drive11RAM4000=1`, `Drive11RAM4000=0`).
`-drive8ram6000, +drive8ram6000`
  Enable/disable 8KB RAM expansion at $6000-$7FFF for drive 8 (`Drive8RAM6000=1`, `Drive8RAM6000=0`).
`-drive9ram6000, +drive9ram6000`
  Enable/disable 8KB RAM expansion at $6000-$7FFF for drive 9 (`Drive9RAM6000=1`, `Drive9RAM6000=0`).
`-drive10ram6000, +drive10ram6000`
  Enable/disable 8KB RAM expansion at $6000-$7FFF for drive 10 (`Drive10RAM6000=1`, `Drive10RAM6000=0`).
`-drive11ram6000, +drive11ram6000`
  Enable/disable 8KB RAM expansion at $6000-$7FFF for drive 11 (`Drive11RAM6000=1`, `Drive11RAM6000=0`).
`-drive8ram8000, +drive8ram8000`
  Enable/disable 8KB RAM expansion at $8000-$9FFF for drive 8 (`Drive8RAM8000=1`, `Drive8RAM8000=0`).
`-drive9ram8000, +drive9ram8000`
  Enable/disable 8KB RAM expansion at $8000-$9FFF for drive 9 (`Drive9RAM8000=1`, `Drive9RAM8000=0`).
`-drive10ram8000, +drive10ram8000`
  Enable/disable 8KB RAM expansion at $8000-$9FFF for drive 10 (`Drive10RAM8000=1`, `Drive10RAM8000=0`).
`-drive11ram8000, +drive11ram8000`
  Enable/disable 8KB RAM expansion at $8000-$9FFF for drive 11 (`Drive11RAM8000=1`, `Drive11RAM8000=0`).
`-drive8rama000, +drive8rama000`
  Enable/disable 8KB RAM expansion at $A000-$BFFF for drive 8 (`Drive8RAMA000=1`, `Drive8RAMA000=0`).
`-drive9rama000, +drive9rama000`
  Enable/disable 8KB RAM expansion at $A000-$BFFF for drive 9 (`Drive9RAMA000=1`, `Drive9RAMA000=0`).
`-drive10rama000, +drive10rama000`
  Enable/disable 8KB RAM expansion at $A000-$BFFF for drive 10 (`Drive10RAMA000=1`, `Drive10RAMA000=0`).
`-drive11rama000, +drive11rama000`
  Enable/disable 8KB RAM expansion at $A000-$BFFF for drive 11 (`Drive11RAMA000=1`, `Drive11RAMA000=0`).
`-drive8profdos`
`+drive8profdos`
  Enable/disable Professional DOS for drive 8 (`Drive8ProfDOS=1`, `Drive8ProfDOS=0`) (x64, x64sc, xscpu64 and x128 only).
`-drive9profdos`
`+drive9profdos`
  Enable/disable Professional DOS for drive 9 (`Drive9ProfDOS=1`, `Drive9ProfDOS=0`) (x64, x64sc, xscpu64 and x128 only).
`-drive10profdos`
`+drive10profdos`
  Enable/disable Professional DOS for drive 10 (`Drive10ProfDOS=1`, `Drive10ProfDOS=0`) (x64, x64sc, xscpu64 and x128 only).
`-drive11profdos`
`+drive11profdos`
  Enable/disable Professional DOS for drive 11 (`Drive11ProfDOS=1`, `Drive11ProfDOS=0`) (x64, x64sc, xscpu64 and x128 only).
`-profdos1571 <name>`
  Specify name of Professional DOS 1571 ROM image (`DriveProfDOS1571Name`) (x64, x64sc, xscpu64 and x128).
`-drive8supercard`
`+drive8supercard`
  Enable/disable Super Card for drive 8 (`Drive8SuperCard=1`, `Drive8SuperCard=0`) (x64, x64sc, xscpu64 and x128 only).
`-drive9supercard`
`+drive9supercard`
  Enable/disable Super Card for drive 9 (`Drive9SuperCard=1`, `Drive9SuperCard=0`) (x64, x64sc, xscpu64 and x128 only).
`-drive10supercard`
`+drive10supercard`
  Enable/disable Super Card for drive 10 (`Drive10SuperCard=1`, `Drive10SuperCard=0`) (x64, x64sc, xscpu64 and x128 only).
`-drive11supercard`
`+drive11supercard`
  Enable/disable Super Card for drive 11 (`Drive11SuperCard=1`, `Drive11SuperCard=0`) (x64, x64sc, xscpu64 and x128 only).
`-supercard <name>`
  Specify name of Super Card ROM image (`DriveSuperCardName`) (x64, x64sc, xscpu64 and x128 only).

## 6.11 Peripheral settings

VICE is able to support some special peripherals:

- file system devices, pseudo-drives accessing the Unix file system;
- printers.

These features depend on some kernal traps that replace the existing routines in the original Commodore operating system with custom-made C routines.

### 6.11.1 Settings for file system devices

These settings deal with the drive-like peripherals connected to the bus of the emulated machine. The first setting relates to the parallel IEEE488 interface. With this interface a special engine is used to listen to the bus lines to translates them to the filesystem code. Thus the PET will always detect a drive for example, but it can also use drives 10 and 11 even together with true disk drive emulation.

- "Enable virtual devices", enables the peripheral access via the fast disk emulation (either kernal traps or IEEE488 interface). Both, filesystem and disk image access via fast drive emulation, are affected.

Four peripherals, numbered from 8 to 11, are accessible; each of them provides the following settings:

- "File system access", if enabled, allows the device to emulate a drive accessing a file system directory; note that when a disk image is attached to the same drive, the directory is no longer visible and the attached disk is used instead.
- "File system directory" specifies the directory to be accessed by the drive.
- "Convert P00 file names", if enabled, allows access to P00 files using their built-in name instead of the Unix one.
- "Create P00 files on save", if enabled, creates P00 files (instead of raw CBM files) whenever a program creates a file.

Note that, by default, all drives create P00 files on save.

#### 6.11.1.1 Resources for file system devices

`IECDevice8`
`IECDevice9`
`IECDevice10`
`IECDevice11`
  Booleans that specify whether IEC device emulation for device #8 to #11 is enabled.
`FileSystemDevice8`
`FileSystemDevice9`
`FileSystemDevice10`
`FileSystemDevice11`
  Integers specifying the device type for device 8-11 respectively (all emulators except vsid). (0: None, 1: Filesystem, 2: OpenCBM (Real), 3: Block Device (Raw))
`FSDevice8ConvertP00`
`FSDevice9ConvertP00`
`FSDevice10ConvertP00`
`FSDevice11ConvertP00`
  Booleans specifying whether on-read support for P00 files is enabled on drives 8, 9, 10 and 11 respectively (all emulators except vsid).
`FSDevice8SaveP00`
`FSDevice9SaveP00`
`FSDevice10SaveP00`
`FSDevice11SaveP00`
  Booleans specifying whether the drives should create P00 files instead of plain CBM ones for drives 8, 9, 10 and 11 respectively (all emulators except vsid).
`FSDevice8HideCBMFiles`
`FSDevice9HideCBMFiles`
`FSDevice10HideCBMFiles`
`FSDevice11HideCBMFiles`
  Booleans specifying whether non-P00 files should be invisible for drives 8, 9, 10 and 11 respectively (all emulators except vsid).
`FSDevice8Dir`
`FSDevice9Dir`
`FSDevice10Dir`
`FSDevice11Dir`
  Strings specifying the directories to which drives 8, 9, 10 and 11 have access (all emulators except vsid).

#### 6.11.1.2 Command-line options for file system devices

`-iecdevice8`
`+iecdevice8`
  Enable/disable IEC device emulation for device #8 (`IECDevice8=1`, `IECDevice8=0`).
`-iecdevice9`
`+iecdevice9`
  Enable/disable IEC device emulation for device #9 (`IECDevice9=1`, `IECDevice9=0`).
`-iecdevice10`
`+iecdevice10`
  Enable/disable IEC device emulation for device #10 (`IECDevice10=1`, `IECDevice10=0`).
`-iecdevice11`
`+iecdevice11`
  Enable/disable IEC device emulation for device #11 (`IECDevice11=1`, `IECDevice11=0`).
`-device8 <type>`
`-device9 <type>`
`-device10 <type>`
`-device11 <type>`
  Set device type for device 8-11 respectively (`FileSystemDevice8`, `FileSystemDevice9`, `FileSystemDevice10`, `FileSystemDevice11`) (all emulators except vsid). (0: None, 1: Filesystem, 2: OpenCBM (Real), 3: Block device (Raw))
`-fs8 <Name>`
`-fs9 <Name>`
`-fs10 <Name>`
`-fs11 <Name>`
  Specify the paths for the file system access on drives 8, 9, 10 and 11, respectively (`FSDevice8Dir`, `FSDevice9Dir`, `FSDevice10Dir` and `FSDevice11Dir`) (all emulators except vsid).
`-fs8convertp00`
`+fs8convertp00`
  Enable/disable on-read support for P00 files on drive 8 (`FSDevice8ConvertP00=1`, `FSDevice8ConvertP00=0`) (all emulators except vsid).
`-fs9convertp00`
`+fs9convertp00`
  Enable/disable on-read support for P00 files on drive 9 (`FSDevice9ConvertP00=1`, `FSDevice9ConvertP00=0`) (all emulators except vsid).
`-fs10convertp00`
`+fs10convertp00`
  Enable/disable on-read support for P00 files on drive 10 (`FSDevice10ConvertP00=1`, `FSDevice10ConvertP00=0`) (all emulators except vsid).
`-fs11convertp00`
`+fs11convertp00`
  Enable/disable on-read support for P00 files on drive 11 (`FSDevice11ConvertP00=1`, `FSDevice11ConvertP00=0`) (all emulators except vsid).
`-fs8savep00`
`+fs8savep00`
  Enable/disable saving P00 files on drive 8 (`FSDevice8SaveP00=1`, `FSDevice8SaveP00=0`) (all emulators except vsid).
`-fs9savep00`
`+fs9savep00`
  Enable/disable saving P00 files on drive 9 (`FSDevice9SaveP00=1`, `FSDevice9SaveP00=0`) (all emulators except vsid).
`-fs10savep00`
`+fs10savep00`
  Enable/disable saving P00 files on drive 10 (`FSDevice10SaveP00=1`, `FSDevice10SaveP00=0`) (all emulators except vsid).
`-fs11savep00`
`+fs11savep00`
  Enable/disable saving P00 files on drive 11 (`FSDevice11SaveP00=1`, `FSDevice11SaveP00=0`) (all emulators except vsid).
`-fs8hidecbm`
`+fs8hidecbm`
  Enable/disable hiding of CBM files for drive 8 (`FSDevice8HideCBMFiles=1`, `FSDevice8HideCBMFiles=0`) (all emulators except vsid).
`-fs9hidecbm`
`+fs9hidecbm`
  Enable/disable hiding of CBM files for drive 9 (`FSDevice9HideCBMFiles=1`, `FSDevice9HideCBMFiles=0`) (all emulators except vsid).
`-fs10hidecbm`
`+fs10hidecbm`
  Enable/disable hiding of CBM files for drive 10 (`FSDevice10HideCBMFiles=1`, `FSDevice10HideCBMFiles=0`) (all emulators except vsid).
`-fs11hidecbm`
`+fs11hidecbm`
  Enable/disable hiding of CBM files for drive 11 (`FSDevice11HideCBMFiles=1`, `FSDevice11HideCBMFiles=0`) (all emulators except vsid).
`-flipname <name>`
  Specify name of the flip list file image (`FliplistName`) (all emulators except vsid).

### 6.11.2 Printer settings

The VICE emulators can emulate printers connected to either the IEC buffer or the user port. Emulation can be achieved by redirecting the printer output to a file or by piping it through an external process. This is defined by so-called printer device file names; a printer device file name can be either a simple path, or a command name preceeded by a pipe symbol ``|'`.

For example, printer device ``filename'` will cause the output to be appended to the file ``filename'`, while printer device ``|lpr'` will cause the `lpr` command to be executed and be fed the printer output. The printer output will not be converted but saved as printed by the emulated machine.

Up to three printer devices may be specified through the following resources:

- device 1, whose default value is `print.dump`;
- device 2, whose default value is `|lpr`.
- device 3, whose default value is `|petlp -F PS|lpr`;

So, basically, by default printer device 1 will dump printer output to ``print.dump'`; printer device 2 will print it via `lpr` directly to the printer and device 3 will print it via `petlp` (a not-yet-complete utility that will produce Postscript output from the Commodore printer code) and then to the printer via `lpr`.

#### 6.11.2.1 Printer resources

`IECDevice4`
`IECDevice5`
`IECDevice6`
`IECDevice7`
  Booleans that specify whether IEC device emulation for device #4, #5, #6 and #7 is enabled.
`PrinterTextDevice1`
`PrinterTextDevice2`
`PrinterTextDevice3`
  Strings specifying the printer devices (see section 6.11.2 Printer settings).
`Printer4TextDevice`
`Printer5TextDevice`
`Printer6TextDevice`
  Integer (ranging from 0 to 2, for device 1-3) specifying what printer device (see section 6.11.2 Printer settings) the IEC printer is using.
`Printer4`
`Printer5`
`Printer6`
  Integer specifying how the printer (device 4-6) is being emulated. (0: None, 1: Filesystem, 2: Real)
`Printer7`
  Integer specifying how printer 7 is being emulated. (0: None, 2: Real)
`Printer4Driver`
  String specifying the printer output driver. (raw, ascii, mps803, nl10)
`Printer5Driver`
  String specifying the printer output driver. (raw, ascii, mps803, nl10)
`Printer6Driver`
  String specifying the printer output driver. (raw, 1520)
`Printer4Output`
`Printer5Output`
`Printer6Output`
  Strings specifying the IEC printer output device. (text, graphics)
`PrinterUserport`
  Boolean specifying if the user-port printer is being emulated.
`PrinterUserportTextDevice`
  Integer (ranging from 0 to 2, for device 1-3) specifying what printer device the user-port printer is using.
`PrinterUserportDriver`
  String specifying the user-port printer output driver. (ascii/nl10/raw)
`PrinterUserportOutput`
  String specifying the user-port printer output device. (text, graphics)

#### 6.11.2.2 Printer command-line options

`-iecdevice4`
`+iecdevice4`
  Enable/disable IEC device emulation for device #4 (`IECDevice4=1`, `IECDevice4=0`).
`-iecdevice5`
`+iecdevice5`
  Enable/disable IEC device emulation for device #5 (`IECDevice5=1`, `IECDevice5=0`).
`-iecdevice6`
`+iecdevice6`
  Enable/disable IEC device emulation for device #6 (`IECDevice6=1`, `IECDevice6=0`).
`-iecdevice7`
`+iecdevice7`
  Enable/disable IEC device emulation for device #7 (`IECDevice7=1`, `IECDevice7=0`).
`-device4 <type>`
  Set device type for device 4 (`Printer4`). (0: None, 1: Filesystem, 2: Real)
`-device5 <type>`
  Set device type for device 5 (`Printer5`). (0: None, 1: Filesystem, 2: Real)
`-device6 <type>`
  Set device type for device 6 (`Printer6`). (0: None, 1: Filesystem, 2: Real)
`-device7 <type>`
  Set device type for device 7 (`Printer7`). (0: None, 2: Real)
`-prtxtdev1 <name>`
`-prtxtdev2 <name>`
`-prtxtdev3 <name>`
  Specify name of printer text device or dump file (`PrinterTextDevice1`, `PrinterTextDevice2`, `PrinterTextDevice3`).
`-pr4txtdev <0-2>`
`-pr5txtdev <0-2>`
`-pr6txtdev <0-2>`
  Specify printer text output device for IEC printer #4-6 (`Printer4TextDevice`, `Printer5TextDevice`, `Printer6TextDevice`).
`-pr4output <name>`
  Specify name of output device for device #4 (`Printer4Output`). (text, graphics)
`-pr5output <name>`
  Specify name of output device for device #5 (`Printer5Output`). (text, graphics)
`-pr6output <name>`
  Specify name of output device for device #6 (`Printer6Output`). (text, graphics)
`-pr4drv <name>`
  Specify name of printer driver for device #4 (`Printer4Driver`). (raw, ascii, mps803, nl10)
`-pr5drv <name>`
  Specify name of printer driver for device #5 (`Printer5Driver`). (raw, ascii, mps803, nl10)
`-pr6drv <name>`
  Specify name of printer driver for device #6 (`Printer6Driver`). (raw, 1520)
`-pruser`
`+pruser`
  Enable/disable emulation of the userport printer emulation (`PrUser=1`, `PrUser=0`).
`-prusertxtdev <0-2>`
  Specify printer text output device for userport printer (`PrinterUserportTextDevice`).
`-pruseroutput <name>`
  Specify name of output device for the userport printer (`PrinterUserportOutput`). (text, graphics)
`-pruserdrv <name>`
  Specify name of printer driver for the userport printer (`PrinterUserportDriver`).

### 6.11.3 Disabling kernal traps

If you have compatibility problems, you can completely disable Kernal traps with the "Disable kernal traps" option. This will of course disable all the features that depend on it, such as the fast 1541 emulation (so you will have to turn true 1541 emulation on if you want to be able to read or write disk images) and tape support.

#### 6.11.3.1 Resources to control Kernal traps

`VirtualDevices`
  Boolean specifying whether all the mechanisms for virtual device emulation should be enabled. Serial IEC devices use kernal traps, parallel IEEE488 devices use an own IEEE488 engine. Both are switched on and off with this resource.

#### 6.11.3.2 Command-line options to control Kernal traps

`-virtualdev`
`+virtualdev`
  Enable/disable virtual devices (`VirtualDevices=1`, `VirtualDevices=0`).

## 6.12 RS232 settings

The VICE emulators can emulate the RS232 device most of the machines have. The C64, C128 and VIC20 emulators emulate the userport RS232 interface at 300 and 1200 baud. The C64 and C128 can also use the 9600 baud interface by Daniel Dallmann, using the shift registers of the two CIA 6526 chips. The PET can have a 6551 ACIA RS232 interface when running as a SuperPET, and the CBM-II has such an ACIA by default. The C64 and C128 emulators can emulate an ACIA 6551 (also known as Datapump for example) as extension at `$de**`.

Emulation can be achieved by either:

- connecting a real UNIX serial device;
- dumping to a file;
- piping through a process.

It is possible to define up to four UNIX serial devices, and then decide which interface should be connected to which device. This is done by so-called rs232 device file names; an rs232 device file name can be either a simple path, or a command name preceeded by a pipe symbol ``|'`. If the path specifies a special device (e.g. ``/dev/ttyS0'`) it is recognized by VICE and the emulator can set the baudrate.

For example, rs232 device ``filename'` will cause the output to be written (not appended) to the file ``filename'`, while printer device ``|lpr'` will cause the `lpr` command to be executed and be fed the rs232 output. The rs232 output will not be converted but saved as sent by the emulated machine. The same holds true for the rs232 input. If the command writes data to the standard output it will be caught by VICE and sent back to the emulator. Also the data sent by the pseudo device will be sent back to VICE.

For example you can setup a null-modem cable between two serial ports of your PC, setup one port for login and use the other in VICE. Then you can login from your emulator via the RS232 emulation and the null-modem cable to your machine again.

You can not simply run a shell from VICE, as the shell will notice that it does not run on its own pseudo terminal and will thus buffer its output. You need to write some program that opens an own pseudo terminal and runs the shell from there (not yet finished).

Up to four RS232 devices may be specified through the following resources:

- device 1, whose default value is `/dev/ttyS0`;
- device 2, whose default value is `/dev/ttyS1`;
- device 3, whose default value is `rs232.dump`;
- device 4, whose default value is `|lpr`.

For the first two devices you can change the baudrate the tty device is set to by specifying it on the commandline or in the menu. This baudrate is 9600 by default for the latter two, but can be changed only by resources (The baudrate is independent from the baudrate the emulator actually expects).

### 6.12.1 RS232 resources

`RsDevice1`
`RsDevice2`
`RsDevice3`
`RsDevice4`
  Strings specifying the RS232 devices (see section 6.12 RS232 settings).
`Acia1Enable`
  Boolean specifying whether the ACIA (Swiftlink, Turbo232) cartridge should be emulated or not (x64, x64sc, xscpu64, x128 and xvic only, and only if RS232 support is enabled and supported at compile time).
`Acia1Dev`
  Integer specifying what RS232 device (see section 6.12 RS232 settings) the ACIA is using (all emulators except x64dtv and vsid, and only if RS232 support is enabled and supported at compile time).
`Acia1Base`
  Integer specifying the base address for the emulated ACIA chip (x64, x64sc, xscpu64, xvic and x128 only, and only if RS232 support is enabled and supported at compile time). (xvic: $9800/$9C00, x128: $D700/$DE00/$DF00, x64/x64sc/xscpu64: $DE00/$DF00)
`Acia1Mode`
  Integer specifying the type of emulated RS232 interface (x64, x64sc, xscpu64, xvic and x128 only, and only if RS232 support is enabled and supported at compile time). (0: normal, 1: Swiftlink, 2: Turbo232)
`Acia1Irq`
  Integer specifying which interrupt to use (x64, x64sc, xscpu64, xvic and x128 only, and only if RS232 support is enabled and supported at compile time). (0 = none, 1 = IRQ, 2 = NMI)
`RsUserEnable`
  Boolean specifying if the user-port RS232 interface is being emulated (C64, C128 and VIC20).
`RsUserBaud`
  Integer specifying the baudrate of the user-port RS232 interface (C64, C128 and VIC20).
`RsUserDev`
  Integer (ranging from 0 to 3, for device 1-4) specifying what RS232 device the user-port interface is using (C64, C128 and VIC20).

### 6.12.2 RS232 command-line options

`-rsdev1 <Name>`
`-rsdev2 <Name>`
`-rsdev3 <Name>`
`-rsdev4 <Name>`
  Specify <Name> as RS232 devices 1, 2, 3 and 4, respectively (`RsDevice1`, `RsDevice2` `RsDevice3` and `RsDevice4`).
`-acia1`
`+acia1`
  Enable/Disable the $DE** ACIA RS232 interface emulation (`Acia1Enable=1`, `Acia1Enable=0`) (x64, x64sc, xscpu64, x128 and xvic only, and only if RS232 support is enabled and supported at compile time).
`-myaciadev <0-3>`
  Specify RS232 device the ACIA should work on (all emulators except x64dtv and vsid, and only if RS232 support is enabled and supported at compile time)
`-acia1base <Base address>`
  Set the base address of the ACIA cartridge (`Acia1Base`) (x64, x64sc, xscpu, x128 and xvic only, and only if RS232 support is enabled and supported at compile time). (xvic: $9800/$9C00, x128: $D700/$DE00/$DF00, x64/x64sc/xscpu: $DE00/$DF00)
`-acia1mode <mode>`
  Set the ACIA mode (`Acia1Mode`) (x64, x64sc, xscpu64, xvic and x128 only, and only if RS232 support is enabled and supported at compile time). (0: Normal, 1: Swiftlink, 2: Turbo232)
`-acia1irq <interrupt>`
  Set the ACIA interrupt (`Acia1Irq`) (x64, x64sc, xscpu64, xvic and x128 only, and only if RS232 support is enabled and supported at compile time). (0: None, 1: NMI, 2: IRQ)
`-rsuser`
`+rsuser`
  Enable or disable emulation of the userport RS232 emulation (`RsUser`; C64, C128 and VIC20)
`-rsuserbaud <baud>`
  Set the baud rate of the RS232 userport emulation.
`-rsuserdev <0-3>`
  Specify device for the userport RS232 emulation (`RsUserDev`; C64, C128 and VIC20).

### 6.12.3 RS232 usage example

Here we give you a simple example how to set up an emulated C64 using the modem connected to your PC. The following list shows each step.

`Attach your modem to your PC at a serial port.`
  Normally you should set it up to use the modem as "/dev/modem".
`start VICE`
`Setup VICE to use your modem as "serial device 1"`
  Go to the RS232 settings menu and change "Serial 1 device" to "/dev/modem" (or the device where you attached your modem to) Then go to the RS232 settings menu and change "Serial 1 baudrate" to the baudrate your modem should run at. Watch out, e.g. on Linux there is an additional multiplier to multiply with the baudrate (so e.g. 19200 gives 115200 or so baud) See the "setserial" manpage on Linux for example. However, most modems should be able to autodetect the speed to the computer as well.
`Select the RS232 emulation your programs use`
  If you want to use the Userport emulation, go to the RS232 settings and change "Userport RS232 Device" to "Serial 1". If you want ACIA emulation (swiftlink or what's it called?) then change "ACIA $DE** device" to "Serial 1".
`Enable the emulation`
  Go to the RS232 settings and select either "ACIA $DE** emulation" or Userport 300/1200 baud or CIA 9600 baud emulation.
`Load your program and start it.`
  If it is able to detect an RS232 cartridge like swiftlink or so, try to detect the ACIA emulation if enabled. Otherwise just set the baudrate to either 300, 1200 or 9600 according to what you enabled in the VICE menu for the userport.

## 6.13 Monitor settings

This section lists command-line options specific to the built-in monitor.

### 6.13.1 Monitor resources

`KeepMonitorOpen`
  Boolean, if true the monitor window may stay open when the emulation is running, eg to look at trace-point output. (Not all ports/UIs support this, in that case this setting has no effect.)
`MonitorServer`
  Boolean specifying whether the remote monitor server is enabled.
`MonitorServerAddress`
  String specifying the address the remote monitor server listens to (ip4://127.0.0.1:6510)

### 6.13.2 Monitor command-line options

`-moncommands <Name>`
  Execute the commands from the file <Name> in the monitor after starting up. This command line switch is mainly thought to load labels and to set breakpoints. Not all other commands are useful to be executed in this way, some may even lead to strange effects.
`-initbreak <address>`
  Set an initial breakpoint for the monitor. Addresses with prefix "0x" are hexadecimal.
`-keepmonopen`
`+keepmonopen`
  Enable/disable keeping the monitor window open (`KeepMonitorOpen=1`, `KeepMonitorOpen=0`).
`-remotemonitor`
`+remotemonitor`
  Enable/Disable remote monitor
`-remotemonitoraddress <name>`
  The local address the remote monitor should bind to

## 6.14 Memory settings

### 6.14.1 Memory resources

`RAMInitStartValue`
  Integer specifying the value for the very first RAM address after powerup (all emulators except vsid). (0..255)
`RAMInitValueInvert`
  Integer specifying the length of the memory block initialized with the same value (all emulators except vsid).
`RAMInitPatternInvert`
  Integer specifying the length of the memory block initialized with the same pattern (all emulators except vsid).

### 6.14.2 Memory command-line options

`-raminitstartvalue <value>`
  Set the value for the very first RAM address after powerup (`RAMInitStartValue`) (all emulators except vsid). (0..255)
`-raminitvalueinvert <num of bytes>`
  Length of memory block initialized with the same value (`RAMInitValueInvert`) (all emulators except vsid).
`-raminitpatterninvert <num of bytes>`
  Length of memory block initialized with the same pattern (`RAMInitPatternInvert`) (all emulators except vsid).

## 6.15 Miscellaneous settings

This section lists generic resources that do not fit in the other categories.

### 6.15.1 Miscellaneous resources

`JAMAction`
  Integer specifying the action to take when the CPU encounters a 'JAM' opcode. (0: show dialog, 1: continue emulation, 2: start monitor, 3: soft reset, 4: hard reset, 5: quit emulator)
`Directory`
  String specifying the search path for system files. It is defined as a sequence of directory names, separated by colons (``:'`), just like the `PATH` variable in the shell. The special string ``$$'` stands for the default search path.
`DoCoreDump`
  Boolean specifying whether the emulator should dump core when it gets a signal (all emulators except vsid).
`NetworkServerName`
  String specifying the name of the remote server.
`NetworkServerBindAddress`
  String specifying the IP of the remote server.
`NetworkServerPort`
  Integer specifying the port used for network play.
`NetworkControl`
  Integer specifying whether the emulator is running as server or client (0: client, 1: server)
`LogFileName`
  String specifying the filename of the current log file.
`FliplistName`
  String specifying the filename of the current flip list. (Drive 8 only) (all emulators except vsid).
`AttachDevice8Readonly`
`AttachDevice9Readonly`
`AttachDevice10Readonly`
`AttachDevice11Readonly`
  Booleans that specify whether to attach images on drives 8 to 11 read-only or not (all emulators except vsid).
`UserportRTC`
  Boolean specifying whether the userport RTC is emulated or not (x64, x64sc, xscpu64 and x128 only).
`UserportRTCSave`
  Boolean specifying whether the userport RTC data is saved when changed or not (x64, x64sc, xscpu64 and x128 only).

### 6.15.2 Miscellaneous command-line options

`-jamaction <Type>`
  Specify the action to take when the CPU encounters a 'JAM' opcode (`JAMAction`) (0: Show dialog, 1: continue emulation, 2: start monitor, 3: soft reset, 4: hard reset, 5: quit emulator).
`-directory <Path>`
  Specify the system file search path (`Directory`).
`-core`
`+core`
  Enable/disable generation of core dumps (`DoCoreDump=1`, `DoCoreDump=0`) (all emulators except vsid).
`-debug`
`+debug`
  Disable/enable calling of the exception handler (`DoCoreDump=1`, `DoCoreDump=0`) (all emulators except vsid).
`-userportrtc`
`+userportrtc`
  Enable/disable the userport RTC emulation (`UserportRTC=1`, `UserportRTC=0`) (x64, x64sc, xscpu64 and x128 only).
`-userportrtcsave`
`+userportrtcsave`
  Disable/enable saving of the userport RTC data when changed (`UserportRTCSave=1`, `UserportRTCSave=0`) (x64, x64sc, xscpu64 and x128 only).

Go to the first, previous, next, last section, table of contents.